package org.apollo.actions;

import org.apollo.items.FramePlaybackLauncher;
import org.apollo.widgets.LinkedTrack;
import org.apollo.widgets.SampleRecorder;
import org.expeditee.gio.gesture.StandardGestureActions;
import org.expeditee.gui.DisplayController;
import org.expeditee.gui.Frame;
import org.expeditee.items.Text;

/**
 * Apollo's action set
 * 
 * @author Brook Novak
 *
 */
public class ApolloActions {

	/** Static-only class. */
	private ApolloActions()
	{
	} 
	
	/** Attaches a new recorder to the cursor. */
	public static void spawnRecorder()
	{
		Frame target = DisplayController.getCurrentFrame();
		if (target  == null) return;

		// Create the widget
		Text source = new Text(target.getNextItemID());
		source.setParent(target);
		source.setPosition(DisplayController.getMousePosition());
		SampleRecorder recWidget = new SampleRecorder(source, null);
		
		// Pick it up
		StandardGestureActions.pickup(recWidget.getItems());
	}
	
	/**
	 * Attatches a new linked track to the cursor
	 */
	public static void spawnLinkedTrack() {
		
		Frame target = DisplayController.getCurrentFrame();
		if (target  == null) return;

		// Create the widget
		Text source = new Text(target.getNextItemID());
		source.setParent(target);
		source.setPosition(DisplayController.getMousePosition());
		
		LinkedTrack ltWidget = new LinkedTrack(source, null);
		
		// Pick it up
		StandardGestureActions.pickup(ltWidget.getItems());
	}
	

	/**
	 * Attatches a new FramePlaybackLauncher to the cursor
	 */
	public static void spawnFramePlayLauncher() {
		
		// Create the launcher
		FramePlaybackLauncher launcher = new FramePlaybackLauncher(null);
		launcher.setPosition(DisplayController.getMousePosition());

		// Pick it up
		StandardGestureActions.pickup(launcher);
	}
	
}
