package org.expeditee.items;

import java.util.Collection;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.expeditee.settings.templates.TemplateSettings;

/**
 * TODO: Comment. cts16
 * 
 * @author cts16
 */
public class Tooltip {

	/** TODO: Comment. cts16 */
	private Map<Text, Item> _tooltipItems = new HashMap<Text, Item>();
	
	/** TODO: Comment. cts16 */
	Tooltip()
	{
	}

	/** TODO: Comment. cts16 */
	public Text addTooltip(String content, final Item toItem)
	{
		if(content.trim().toLowerCase().startsWith("text") && content.contains(":")) {
			content = content.substring(content.indexOf(':') + 1);
		}
		final Text tooltip = TemplateSettings.TooltipTemplate.get().copy();
		tooltip.setWidth(Integer.MAX_VALUE); // Tooltip shouldn't be width-limited
		tooltip.setText(content);
		return addTooltip(tooltip, toItem);
	}

	/** TODO: Comment. cts16 */
	public Text addTooltip(final Text tooltip, final Item toItem)
	{
		_tooltipItems.put(tooltip, toItem);
		return tooltip;
	}

	/** TODO: Comment. cts16 */
	public Collection<Text> getTooltips()
	{
		return _tooltipItems.keySet();
	}

	/** TODO: Comment. cts16 */
	public List<String> asStringList()
	{ 
		final List<String> ret = new LinkedList<String>();
		for(final Text tooltip: _tooltipItems.keySet()) ret.add(tooltip.getText());
		return ret;
	}

	/** TODO: Comment. cts16 */
	public int getWidth()
	{
		int max = 0;
		for(final Text tooltip: _tooltipItems.keySet()) {
			if(tooltip.getBoundsWidth() > max) max = tooltip.getBoundsWidth();
		}
		return max;
	}

	/** TODO: Comment. cts16 */
	public int getHeight()
	{
		int max = 0;
		for(final Text tooltip: _tooltipItems.keySet()) {
			if(tooltip.getBoundsWidth() > max) max = tooltip.getBoundsHeight();
		}
		return max;
	}

	/** TODO: Comment. cts16 */
	public int getCollectiveHeight()
	{
		int height = 0;
		for(final Text tooltip: _tooltipItems.keySet()) height += tooltip.getBoundsHeight();
		return height;
	}
}
